abuild.in 31.7 KB
Newer Older
Natanael Copa's avatar
Natanael Copa committed
1 2
#!/bin/sh

3
# script to build apk packages (light version of makepkg)
Natanael Copa's avatar
Natanael Copa committed
4 5 6 7 8 9 10
# Copyright (c) 2008 Natanael Copa <natanael.copa@gmail.com>
#
# Distributed under GPL-2
#
# Depends on: busybox utilities, fakeroot, 
#

Natanael Copa's avatar
Natanael Copa committed
11 12
abuild_ver=@VERSION@
sysconfdir=@sysconfdir@
13
abuildrepo=@abuildrepo@
Natanael Copa's avatar
Natanael Copa committed
14
datadir=@datadir@
Natanael Copa's avatar
Natanael Copa committed
15

16
program=${0##*/}
17
abuild_path=$(readlink -f $0)
Natanael Copa's avatar
Natanael Copa committed
18 19

# defaults
20
BUILD_BASE="build-base"
21
SUDO=${SUDO:-"sudo"}
22
FAKEROOT=${FAKEROOT:-"fakeroot"}
23
APK=${APK:-apk}
24

Natanael Copa's avatar
Natanael Copa committed
25
# read config
Natanael Copa's avatar
Natanael Copa committed
26
ABUILD_CONF=${ABUILD_CONF:-"$sysconfdir/abuild.conf"}
Natanael Copa's avatar
Natanael Copa committed
27 28
[ -f "$ABUILD_CONF" ] && . "$ABUILD_CONF"

29
default_colors() {
Natanael Copa's avatar
Natanael Copa committed
30 31 32 33 34 35
	NORMAL="\033[1;0m"
	STRONG="\033[1;1m"
	RED="\033[1;31m"
	GREEN="\033[1;32m"
	YELLOW="\033[1;33m"
	BLUE="\033[1;34m"
36 37 38 39 40 41 42 43 44 45 46 47 48 49
}

monochrome() {
	NORMAL=""
	STRONG=""
	RED=""
	GREEN=""
	YELLOW=""
	BLUE=""
}

#colors
if [ -n "$USE_COLORS" ]; then
    default_colors
Natanael Copa's avatar
Natanael Copa committed
50 51 52 53 54 55 56 57 58 59 60 61 62 63 64 65 66 67 68 69 70 71 72 73
fi	
	

# functions
msg() {
	local prompt="$GREEN>>>${NORMAL}"
	local fake="${FAKEROOTKEY:+${BLUE}*${NORMAL}}"
	local name="${STRONG}${subpkgname:-$pkgname}${NORMAL}"
	[ -z "$quiet" ] && printf "${prompt} ${name}${fake}: $@\n" >&2
}

warning() {
	local prompt="${YELLOW}>>> WARNING:${NORMAL}"
	local fake="${FAKEROOTKEY:+${BLUE}*${NORMAL}}"
	local name="${STRONG}${subpkgname:-$pkgname}${NORMAL}"
	printf "${prompt} ${name}${fake}: $@\n" >&2
}

error() {
	local prompt="${RED}>>> ERROR:${NORMAL}"
	local fake="${FAKEROOTKEY:+${BLUE}*${NORMAL}}"
	local name="${STRONG}${subpkgname:-$pkgname}${NORMAL}"
	printf "${prompt} ${name}${fake}: $@\n" >&2
}
Natanael Copa's avatar
Natanael Copa committed
74 75

	
Linux User's avatar
Linux User committed
76
set_xterm_title() {
77
	if [ "$TERM" = xterm ] && [ -n "$USE_COLORS" ]; then
78
		 printf "\033]0;$1\007" >&2
Linux User's avatar
Linux User committed
79 80 81 82 83
	fi
} 

cleanup() {
	set_xterm_title ""
84
	if [ -z "$install_after" ] && [ -n "$uninstall_after" ]; then
85
		$SUDO $APK del $uninstall_after
86
	fi
Linux User's avatar
Linux User committed
87 88
}

Natanael Copa's avatar
Natanael Copa committed
89
die() {
Linux User's avatar
Linux User committed
90
	error "$@"
Linux User's avatar
Linux User committed
91
	cleanup
Natanael Copa's avatar
Natanael Copa committed
92 93 94
	exit 1
}

95 96
# check if apkbuild is basicly sane
sanitycheck() {
97
	local i suggestion
98
	msg "Checking sanity of $APKBUILD..."
99 100 101
	[ -z "$pkgname" ] && die "Missing pkgname in APKBUILD"
	[ -z "${pkgname##* *}" ] && die "pkgname contains spaces"
	[ -z "$pkgver" ] && die "Missing pkgver in APKBUILD"
102
	if [ "$pkgver" != "volatile" ] && [ -z "$nodeps" ]; then
103
		$APK version --check -q "$pkgver" ||\
Natanael Copa's avatar
Natanael Copa committed
104 105
			die "$pkgver is not a valid version"
	fi
106
	[ -z "$pkgrel" ] && die "Missing pkgrel in APKBUILD"
107 108 109 110
	[ -z "$pkgdesc" ] && die "Missing pkgdesc in APKBUILD"
	[ -z "$url" ] && die "Missing url in APKBUILD"
	[ -z "$license" ] && die "Missing license in APKBULID"

111 112 113 114 115 116 117 118 119 120
	# check if CARCH, CBUILD, CHOST and CTARGET is set
	if [ -z "$CARCH" ]; then
		case "$(uname -m)" in
		i[0-9]86) suggestion=" (Suggestion: CARCH=x86)";;
		x86_64) suggestion=" (Suggestion: CARCH=x86_64)";;
		esac
		die "Please set CARCH in /etc/abuild.conf$suggestion"
	fi
	[ -z "$CHOST" ] && die "Please set CHOST in /etc/abuild.conf"

Natanael Copa's avatar
Natanael Copa committed
121 122 123 124 125 126 127
	for i in $install; do
		[ -e "$startdir/$i" ] || die "install script $startdir/$i is missing"
	done
	
	[ -n "${triggers%%:*}" ] && [ ! -e "$startdir"/${triggers%%:*} ] \
		&& die "trigger script $startdir/${triggers%%:*} is missing"

128 129
	if [ -n "$source" ]; then
		for i in $source; do
Natanael Copa's avatar
Natanael Copa committed
130 131 132 133
			if install_has "$i"; then
				warning "You should not have \$install in source"
				continue
			fi
134
			md5sums_has ${i##*/} || die "${i##*/} is missing in md5sums"
Natanael Copa's avatar
Natanael Copa committed
135 136 137
			case "$i" in
				https://*) makedepends_has wget || die "wget must be in makedepends when source has https://" ;;
			esac
138 139
		done
	fi
Natanael Copa's avatar
Natanael Copa committed
140

141 142
	if [ -n "$md5sums" ]; then
		for i in $(echo "$md5sums" | awk '{ print $2 }'); do
Natanael Copa's avatar
Natanael Copa committed
143
			source_has $i || die "$i exists in md5sums but is missing in source"
144 145
		done
	fi
146

147 148 149
	# common spelling errors
	[ -n "$depend" ] && die "APKBUILD contains 'depend'. It should be depends"
	[ -n "$makedepend" ] && die "APKBUILD contains 'makedepend'. It should be makedepends"
Natanael Copa's avatar
Natanael Copa committed
150 151

	grep '^# Maintainer:' $APKBUILD >/dev/null || warning "No maintainer"
152 153

	makedepends_has 'g++' && warning "g++ should not be in makedepends"
154 155 156 157
	return 0
}

md5check() {
Natanael Copa's avatar
Natanael Copa committed
158
	local dummy f
159 160 161
	if [ -z "$source" ]; then
		return 0
	fi
162
	if [ -z "$md5sums" ]; then
163
		die "Use 'abuild checksum' to generate/update the checksum(s)"
164
	fi
165 166 167
	if [ "$(echo $source | wc -l)" -ne "$(echo $md5sums | wc -l)" ]; then
		die "Number of md5sums does not correspond to number of sources"
	fi
168
	fetch || return 1
169
	msg "Checking md5sums..."
170
	cd "$srcdir" && echo "$md5sums" | md5sum -c 
Natanael Copa's avatar
Natanael Copa committed
171 172
}

Natanael Copa's avatar
Natanael Copa committed
173 174
# verify upstream sources
sourcecheck() {
175 176 177 178 179 180 181 182 183 184
	local uri
	for uri in $source; do
		is_remote $uri || continue
		case "$uri" in
		saveas-*://*)
			uri=${uri#saveas-}
			uri=${uri%/*}
			;;
		esac
		wget -q -s "$uri" || return 1
Natanael Copa's avatar
Natanael Copa committed
185
	done
186
	return 0
Natanael Copa's avatar
Natanael Copa committed
187
}
188

Natanael Copa's avatar
Natanael Copa committed
189 190
uri_fetch() {
	local uri="$1"
191
	local d="${uri##*/}"	# $(basename $uri)
192 193 194 195
	local opts
	[ -n "$quiet" ] && opts="-q"
	[ -f "$SRCDEST/$d" ] && return 0

196 197 198 199 200
	# fix saveas-*://* URIs
	case "$uri" in
		# remove 'saveas-' from beginning and
		# '/filename' from end of URI
		saveas-*://*) uri="${uri:7:$(expr ${#uri} - 7 - ${#d} - 1)}";;
Natanael Copa's avatar
Natanael Copa committed
201
	esac
202 203 204 205 206

	# we need GNU wget for this
	case "$uri" in
		https://*) opts="--no-check-certificate";;
	esac
Natanael Copa's avatar
Natanael Copa committed
207
	
Natanael Copa's avatar
Natanael Copa committed
208
	mkdir -p "$SRCDEST"
209 210 211
	if [ -f "$SRCDEST/$d.part" ]; then
		msg "Partial download found. Trying to resume"
		opts="$opts -c"
Natanael Copa's avatar
Natanael Copa committed
212
	fi
Linux User's avatar
Linux User committed
213
	msg "Fetching $uri"
214 215
	wget $opts -O "$SRCDEST/$d.part" "$uri" \
		&& mv "$SRCDEST/$d.part" "$SRCDEST/$d"
Natanael Copa's avatar
Natanael Copa committed
216 217
}

218 219
is_remote() {
	case "$1" in
220
		http://*|ftp://*|https://*|saveas-*://*)
221 222 223 224 225
			return 0;;
	esac
	return 1
}

226 227 228 229 230
# try download from file from mirror first
uri_fetch_mirror() {
	local uri="$1"
	local d="${uri##*/}"	# $(basename $uri)
	if [ -n "$DISTFILES_MIRROR" ]; then
231 232 233 234 235
		if is_remote "$DISTFILES_MIRROR"; then
			uri_fetch "$DISTFILES_MIRROR"/$d && return 0
		else
			cp "$DISTFILES_MIRROR"/$d "$SRCDEST" && return 0
		fi
236 237 238 239
	fi
	uri_fetch "$uri"
}

240
default_fetch() {
Natanael Copa's avatar
Natanael Copa committed
241 242
	local s
	mkdir -p "$srcdir"
243 244
	for s in $source; do
		if is_remote "$s"; then
245
			uri_fetch_mirror "$s" || return 1
246 247 248 249
			ln -sf "$SRCDEST/${s##*/}" "$srcdir"/
		else		
			ln -sf "$startdir/$s" "$srcdir/"
		fi
Natanael Copa's avatar
Natanael Copa committed
250 251 252
	done
}

253 254 255 256
fetch() {
	default_fetch
}

Natanael Copa's avatar
Natanael Copa committed
257 258 259 260 261 262 263 264 265 266 267 268 269 270 271
# verify that all init.d scripts are openrc runscripts
initdcheck() {
	local i
	for i in $source; do
		case $i in
		*.initd)
			head -n 1 "$srcdir"/$i | grep -q '/sbin/runscript' \
				&& continue
			error "$i is not an openrc #!/sbin/runscript"
			return 1
			;;
		esac
	done			
}

Natanael Copa's avatar
Natanael Copa committed
272
# unpack the sources
273
default_unpack() {
Natanael Copa's avatar
Natanael Copa committed
274
	local u
275 276
	if [ -z "$force" ]; then
		md5check || return 1
Natanael Copa's avatar
Natanael Copa committed
277
		initdcheck || return 1
278
	fi
Natanael Copa's avatar
Natanael Copa committed
279 280 281 282
	mkdir -p "$srcdir"
	for u in $source; do
		local s="$SRCDEST/${u##*/}"	# $(basename $s)
		case "$s" in
Natanael Copa's avatar
Natanael Copa committed
283
			*.tar.gz|*.tgz)
284
				msg "Unpacking $s..."
Natanael Copa's avatar
Natanael Copa committed
285 286
				tar -C "$srcdir" -zxf "$s" || return 1;;
			*.tar.bz2)
287
				msg "Unpacking $s..."
Natanael Copa's avatar
Natanael Copa committed
288
				tar -C "$srcdir" -jxf "$s" || return 1;;
289 290 291 292
			*.tar.lzma)
				msg "Unpacking $s..."
				unlzma -c "$s" | tar -C "$srcdir" -x  \
					|| return 1;;
293 294 295
			*.tar.xz)
				msg "Unpacking $s..."
				unxz -c "$s" | tar -C "$srcdir" -x || return 1;;
Natanael Copa's avatar
Natanael Copa committed
296 297 298
			*.zip)
				msg "Unpacking $s..."
				unzip "$s" -d "$srcdir" || return 1;;
Natanael Copa's avatar
Natanael Copa committed
299 300 301 302
		esac
	done
}

303 304 305 306
unpack() {
	default_unpack
}

Natanael Copa's avatar
Natanael Copa committed
307 308
# cleanup source and package dir
clean() {
309
	msg "Cleaning temporary build dirs..."
Natanael Copa's avatar
Natanael Copa committed
310
	rm -rf "$srcdir"
311
	rm -rf "$pkgbasedir"
Natanael Copa's avatar
Natanael Copa committed
312 313 314 315 316 317
}

# cleanup fetched sources
cleancache() {
	local s
	for s in $source; do
318 319 320 321
		if is_remote "$s"; then
			msg "Cleaning downloaded ${s##*/}..."
			rm -f "$SRCDEST/${s##*/}"
		fi
Natanael Copa's avatar
Natanael Copa committed
322 323 324
	done
}

325 326 327 328 329 330 331 332 333 334
listpkgnames() {
	local i
	for i in $pkgname $subpackages; do
		echo ${i%:*}
	done
	for i in $linguas; do
		echo $pkgname-lang-$i
	done
}

Natanael Copa's avatar
Natanael Copa committed
335 336
cleanpkg() {
	local i
337
	getpkgver || return 1
338
	msg "Cleaning built packages..."
339
	for i in $(listpkgnames); do
340 341
		local p="${i%:*}-$pkgver-r$pkgrel"
		rm -f "$PKGDEST/$p.apk" "$PKGDEST/$p.src.tar.gz" \
342
			"$abuildrepo"/$p.apk
Natanael Copa's avatar
Natanael Copa committed
343
	done
344
	# remove given packages from index
Natanael Copa's avatar
Natanael Copa committed
345 346
}

347 348 349
# clean all packages except current
cleanoldpkg() {
	local i j
350
	getpkgver || return 1
351
	msg "Cleaning all packages except $pkgver-r$pkgrel..."
352
	for i in $(listpkgnames); do
353 354 355 356 357 358 359
		for j in "$PKGDEST"/${i%:*}-[0-9]*.apk; do
			[ "$j" != "$PKGDEST/${i%:*}-$pkgver-r$pkgrel.apk" ] \
				&& rm -f "$j"
		done
	done
	return 0
}
360 361 362 363 364 365 366 367 368 369 370 371 372 373 374 375 376 377

mkusers() {
	local i
	for i in $pkgusers; do
		if ! getent passwd $i >/dev/null; then
			msg "Creating user $i"
			$SUDO adduser -D -H $i || return 1
		fi
	done
	for i in $pkggroups; do
		if ! getent group $i >/dev/null; then
			msg "Creating group $i"
			$SUDO addgroup $i || return 1
		fi
	done
}


Natanael Copa's avatar
Natanael Copa committed
378 379
runpart() {
	local part=$1
380
	[ -n "$DEBUG" ] && msg "$part"
Natanael Copa's avatar
Natanael Copa committed
381 382 383 384
	$part || die "$part failed"
}

# override those in your build script
385 386 387 388 389 390 391 392
getpkgver() {
	# this func is supposed to be overridden by volatile packages
	if [ "$pkgver" = "volatile" ]; then
		error "Please provide a getpkgver() function in your APKBUILD"
		return 1
	fi
}

Natanael Copa's avatar
Natanael Copa committed
393 394 395 396
prepare() {
	:
}

Natanael Copa's avatar
Natanael Copa committed
397
build() {
398
	:
Natanael Copa's avatar
Natanael Copa committed
399 400
}

401 402 403 404 405 406
# generate a simple tar.gz package of pkgdir
targz() {
	cd "$pkgdir" || return 1
	tar -czf "$PKGDEST"/$pkgname-$pkgver-r$pkgrel.tar.gz *
}

Natanael Copa's avatar
Natanael Copa committed
407 408 409 410 411 412 413 414 415
get_split_func() {
	# get the 'func' from "sub-pkg:func"
	local func=${1##*:}

	# get 'func' from "sub-pkg-func" if there was no :func
	[ "$func" = "$1" ] && func=${func##*-}
	echo $func
}

416
prepare_subpackages() {
Natanael Copa's avatar
Natanael Copa committed
417 418
	local i
	cd "$startdir"
419
	for i in $subpackages; do
Natanael Copa's avatar
Natanael Copa committed
420 421
		local func=$(get_split_func $i)
		# call abuild recursively, setting subpkg{dir,name}
422
		msg "Running split function $func..."
423
		subpkgdir="$pkgbasedir/${i%:*}" subpkgname="${i%:*}" \
424
			$0 $func prepare_package || return 1
Natanael Copa's avatar
Natanael Copa committed
425 426 427
	done
}

428 429 430 431 432 433 434 435 436 437 438 439 440 441 442 443 444 445 446 447 448 449
lang_subpkg() {
	if [ -z "$lang" ]; then
		error "lang is not set"
		return 1
	fi
	arch="noarch"
	install_if="$pkgname=$pkgver-r$pkgrel lang-$lang"
	mkdir -p "$subpkgdir"/usr/share/locale
	mv "$pkgdir"/usr/share/locale/$lang* \
		"$subpkgdir"/usr/share/locale/ \
		|| return 1
}

prepare_language_packs() {
	for lang in $linguas; do
		lang="$lang" \
		subpkgname="$pkgname-lang-$lang" \
		subpkgdir="$pkgbasedir"/$subpkgname \
			$0 lang_subpkg prepare_package || return 1
	done
}

450 451 452 453 454 455 456 457 458 459 460 461
# echo '-dirty' if git is not clean
git_dirty() {
	if [ $(git status -s "$startdir" | wc -l) -ne 0 ]; then
		echo "-dirty"
	fi
}

# echo last commit hash id
git_last_commit() {
	git log --format=oneline -n 1 "$startdir" | awk '{print $1}'
}

462 463 464 465 466 467
get_maintainer() {
	if [ -z "$maintainer" ]; then
		maintainer=$(awk -F': ' '/\# *Maintainer/ {print $2}' "$APKBUILD")
	fi
}

468
prepare_metafiles() {
469
	getpkgver || return 1
470 471
	local name=${subpkgname:-$pkgname}
	[ -z "${name##* *}" ] && die "package name contains spaces"
472
	local dir=${subpkgdir:-$pkgdir}
473
	local pkg="$name-$pkgver-r$pkgrel.apk"
474
	local pkginfo="$controldir"/.PKGINFO
475
	local sub
Natanael Copa's avatar
Natanael Copa committed
476 477 478
	
	[ ! -d "$dir" ] && die "Missing $dir"
	cd "$dir"
479
	mkdir -p "$controldir"
Natanael Copa's avatar
Natanael Copa committed
480 481
	local builddate=$(date -u "+%s")
	local size=$(du -sk | awk '{print $1 * 1024}')
Natanael Copa's avatar
Natanael Copa committed
482 483 484 485
	local parch="$CARCH"
	if [ "$arch" = "noarch" ]; then
		parch="noarch"
	fi
Natanael Copa's avatar
Natanael Copa committed
486

487
	echo "# Generated by $(basename $0) $abuild_ver" >"$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
488
	if [ -n "$FAKEROOTKEY" ]; then
489
		echo "# using $($FAKEROOT -v)" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
490
	fi
491 492
	echo "# $(date -u)" >> "$pkginfo"
	cat >> "$pkginfo" <<EOF
493
pkgname = $name
494
pkgver = $pkgver-r$pkgrel
Natanael Copa's avatar
Natanael Copa committed
495 496 497 498 499
pkgdesc = $pkgdesc
url = $url
builddate = $builddate
packager = ${PACKAGER:-"Unknown"}
size = $size
Natanael Copa's avatar
Natanael Copa committed
500
arch = $parch
Natanael Copa's avatar
Natanael Copa committed
501
EOF
502 503
	local i deps
	deps="$depends"
504
	if [ "$pkgname" != "busybox" ] && ! depends_has busbox; then
Natanael Copa's avatar
Natanael Copa committed
505 506
		for i in $install ${triggers%%:*}; do
			if head -n 1 "$startdir/$i" | grep '^#!/bin/sh' >/dev/null ; then
507 508 509 510 511
				msg "Script found. busybox added as a dependency for $pkg"
				deps="$deps busybox"
				break
			fi
		done
512 513
	fi
	
514 515 516 517 518 519 520 521 522 523
	local last_commit="$(git_last_commit)$(git_dirty)"
	if [ -n "$last_commit" ]; then
		echo "commit = $last_commit" >> "$pkginfo"
	fi

	get_maintainer
	if [ -n "$maintainer" ]; then
		echo "maintainer = $maintainer" >> "$pkginfo"
	fi

Natanael Copa's avatar
Natanael Copa committed
524
	for i in $license; do
525
		echo "license = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
526 527
	done
	for i in $replaces; do
528
		echo "replaces = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
529
	done
530
	for i in $deps; do
531
		echo "depend = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
532 533
	done
	for i in $conflicts; do
534
		echo "conflict = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
535 536
	done
	for i in $provides; do
537
		echo "provides = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
538
	done
Natanael Copa's avatar
Natanael Copa committed
539 540 541
	if [ -n "$triggers" ]; then
		echo "triggers = ${triggers#*:}" >> "$pkginfo"
	fi
542 543 544
	if [ -n "$install_if" ]; then
		echo "install_if = $(echo $install_if)" >> "$pkginfo"
	fi
Natanael Copa's avatar
Natanael Copa committed
545 546

	local metafiles=".PKGINFO"
Natanael Copa's avatar
Natanael Copa committed
547
	for i in $install ${triggers%%:*}; do
548 549
		script=${i#$name}
		case "$script" in
Natanael Copa's avatar
Natanael Copa committed
550
			.pre-install|.post-install|.pre-upgrade|.post-upgrade|.pre-deinstall|.post-deinstall|.trigger)
551 552
				msg "Adding $script"
				;;
Natanael Copa's avatar
Natanael Copa committed
553
			*) 	error "$script: Invalid install/trigger script"
554 555 556
				return 1
				;;
		esac
Natanael Copa's avatar
Natanael Copa committed
557
		cp "$startdir/$i" "$controldir/$script" || return 1
558
		chmod +x "$controldir/$script"
559 560
		metafiles="$metafiles $script"
	done
561
	echo $metafiles | tr ' ' '\n' > "$controldir"/.metafiles
562
}
563

564 565
prepare_tracedeps() {
	local dir=${subpkgdir:-$pkgdir}
566
	[ "$arch" = "noarch" ] && return 0
567
	options_has "!tracedeps" && return 0
568
	# lets tell all the .so files this package provides in .provides-so
569 570
	find -name '*.so' -o -name '*.so.[0-9]*' | sed 's:.*/::' \
		>"$controldir"/.provides-so
571 572 573 574 575
	# lets tell all the places we should look for .so files - all rpaths
	scanelf -q -Rr "$dir" | sed -e 's/[[:space:]].*//' -e 's/:/\n/' \
		| sort | uniq \
		>"$controldir"/.rpaths
	# now find the so dependencies
576
	scanelf -Rn "$dir" | tr ' ' ':' | awk -F ":" '$1 == "ET_DYN" || $1 == "ET_EXEC" {print $2}'  \
577 578 579
		| sed 's:,:\n:g' | sort | uniq \
	| while read i; do
		# only add files that are not self provided
580 581
		grep "^$i$" "$controldir"/.provides-so >/dev/null \
			|| echo $i >> "$controldir"/.needs-so
582
	done
Natanael Copa's avatar
Natanael Copa committed
583 584
}

585 586 587 588 589 590 591 592 593 594 595 596
# check if dir has arch specific binaries
dir_has_arch_binaries() {
	local dir="$1"
	# if scanelf returns something, then we have binaries
	[ -n "$(scanelf -R "$dir" | head -n 1)" ] && return 0

	# look for static *.a
	[ -n "$(find "$dir" -type f -name '*.a' | head -n 1)" ] && return 0

	return 1
}

597 598 599 600 601
# returns true if this is the -dev package
is_dev_pkg() {
	test "${subpkgname%-dev}" != "$subpkgname"
}

602 603 604 605 606 607 608
# check that noarch is set if needed
archcheck() {
	options_has "!archcheck" && return 0
	if dir_has_arch_binaries "${subpkgdir:-$pkgdir}"; then
		[ "$arch" != "noarch" ] && return 0
		error "Arch specific binaries found so arch must not be set to \"noarch\""
		return 1
609 610 611
	elif [ "$arch" != "noarch" ] && ! is_dev_pkg; then
		# we dont want -dev package go to noarch
		warning "No arch specific binaries found so arch should probably be set to \"noarch\""
612 613 614 615
	fi
	return 0
}

616
prepare_package() {
617
	msg "Preparing ${subpkgname:+sub}package ${subpkgname:-$pkgname}..."
618
	stripbin
619 620
	prepare_metafiles && prepare_tracedeps || return 1
	archcheck	
621 622 623 624 625 626 627 628
}

pkginfo_val() {
	local key="$1"
	local file="$2"
	awk -F ' = ' "\$1 == \"$key\" {print \$2}" "$file"
}

629 630 631 632 633 634 635 636 637 638 639 640 641 642 643 644 645 646 647 648 649 650 651
# find real path to so files
real_so_path() {
	local so="$1"
	shift
	while [ $# -gt 0 ]; do
		[ -e "$1"/$so ] && realpath "$1/$so" && return 0
		shift
	done
	error "$so: path not found"
	return 1
}

# search rpaths and /usr/lib /lib for given so files
find_so_files() {
	local rpaths=$(cat "$1")
	shift
	while [ $# -gt 0 ]; do
		real_so_path "$1" /usr/lib /lib $rpaths || return 1
		shift
	done
	return 0
}

652 653 654
trace_apk_deps() {
	local name="$1"
	local dir="$2"
Natanael Copa's avatar
Natanael Copa committed
655
	local i= j= found= autodeps= deppkgs= missing= so_paths= self_provided=
656
	msg "Tracing dependencies for $name..."
657 658 659
	# add pkgconfig if usr/lib/pkgconfig is found
	if [ -d "$pkgbasedir"/$name/usr/lib/pkgconfig ] \
			&& ! grep -q '^depend = pkgconfig' "$dir"/.PKGINFO; then
660
		msg "  added pkgconfig (found /usr/lib/pkgconfig)"
661 662 663 664
		autodeps="$autodeps pkgconfig"
	fi

	# special case for libpthread: we need depend on libgcc
665
	if [ -f "$dir"/.needs-so ] && grep -q -w '^libpthread.so.*' "$dir"/.needs-so \
666 667
			&& ! grep -q -w "^depend = libgcc" "$dir"/.PKGINFO; then
		autodeps="$autodeps libgcc"
668
		msg "  added libgcc (due to libpthread)"
669
	fi
670
	[ -f "$dir"/.needs-so ] && for i in $(cat "$dir"/.needs-so); do
671
		found=
672
		# first check if its provide by same apkbuild
673
		for j in "$dir"/../.control.*/.provides-so; do
674
			grep -w "$i" "$j" >/dev/null || continue
675
			found=${j%/.provides-so}
676
			found=${found##*/.control.}
677
			break
678
		done
679 680 681 682 683 684
		if [ -n "$found" ]; then
			if ! list_has "$found" $self_provided; then
				self_provided="$self_provided $found"
			fi
		else
			missing="$missing $i"
685
		fi
686 687 688
	done

	# find all packages that holds the so files
689 690 691 692 693
	if [ -f "$dir"/.rpaths ]; then
		so_files=$(find_so_files "$dir"/.rpaths $missing) || return 1
		deppkgs=$($APK info -q -W $so_files) || return 1
	fi

694
	for found in $self_provided $deppkgs; do
695
		if grep -w "^depend = ${found}$" "$dir"/.PKGINFO >/dev/null ; then
696 697 698
			warning "You can remove '$found' from depends"
			continue
		fi
699 700
		if [ "$found" != "$name" ] && ! list_has "$found" $autodeps; then
			autodeps="$autodeps $found"
701
			msg "  added $found"
702
		fi
703
	done
704

705 706 707 708 709 710 711
	[ -z "$autodeps" ] && return 0
	echo "# automatically detected:" >> "$dir"/.PKGINFO
	for i in $autodeps; do
		echo "depend = $i" >> "$dir"/.PKGINFO
	done
}

712 713
create_apks() {
	local file
714
	getpkgver || return 1
715
	for file in "$pkgbasedir"/.control.*/.PKGINFO; do
716 717 718
		local dir="${file%/.PKGINFO}"
		local name=$(pkginfo_val pkgname $file)
		local ver=$(pkginfo_val pkgver $file)
719
		local apk=$name-$ver.apk
720
		local datadir="$pkgbasedir"/$name
721 722

		trace_apk_deps "$name" "$dir" || return 1
723
		msg "Creating $apk..."
724
		(
725 726
		cd "$datadir"
		# data.tar.gz
727 728 729 730 731 732
		set -- *
		if [ "$1" = '*' ]; then
			touch .dummy
			set -- .dummy
		fi
		tar -c "$@" | abuild-tar --hash | gzip -9 >"$dir"/data.tar.gz
733 734 735 736 737 738

		# append the hash for data.tar.gz
		local sha256=$(sha256sum "$dir"/data.tar.gz | cut -f1 -d' ')
		echo "datahash = $sha256" >> "$dir"/.PKGINFO

		# control.tar.gz
739
		cd "$dir"
740 741
		tar -c $(cat "$dir"/.metafiles) | abuild-tar --cut \
			| gzip -9 > control.tar.gz
742
		abuild-sign -q control.tar.gz || exit 1
Natanael Copa's avatar
Natanael Copa committed
743

744 745 746
		# create the final apk
		cat control.tar.gz data.tar.gz > "$PKGDEST"/$apk
	)
747 748 749
	done
}

750
update_abuildrepo() {
751
	if ! apk_up2date || [ -n "$force" ]; then
752
		sanitycheck && builddeps && clean && fetch && unpack \
Natanael Copa's avatar
Natanael Copa committed
753
			&& prepare && mkusers && rootpkg || return 1
754
	fi
755

756
	local apk
757 758
	mkdir -p "$abuildrepo" || return 1
	cd "$abuildrepo"
759 760 761 762 763 764 765 766 767

	# remove broken links
	for apk in *.apk; do
		if [ -L "$apk" ] && [ ! -f "$apk" ]; then
			rm -f "$apk"
		fi
	done

	# create links for this package
768
	for apk in $(listpkg); do
769
		ln -sf "$PKGDEST"/$apk "$abuildrepo"/$apk
770 771
	done

772
	msg "Updating the cached abuild repository index..."
773 774 775 776 777
	local sign=".SIGN.RSA.${SIGN_PUBLIC_KEY##*/}"
	local oldindex=
	if [ -f APKINDEX.tar.gz ]; then
		oldindex="--index APKINDEX.tar.gz"
	fi
778
	$APK index $oldindex --output APKINDEX.tar.gz.unsigned \
779 780
		--description "$repo $(cd $startdir && git describe)" \
		*.apk || exit 1
781 782 783
	msg "Signing the index..."
	abuild-sign -q APKINDEX.tar.gz.unsigned || exit 1
	mv APKINDEX.tar.gz.unsigned APKINDEX.tar.gz
Natanael Copa's avatar
Natanael Copa committed
784
	chmod 644 APKINDEX.tar.gz
785 786
}

787
# predefined splitfunc doc
788
default_doc() {
789
	depends="$depends_doc"
790
	install="$install_doc"
Natanael Copa's avatar
Natanael Copa committed
791
	triggers="$triggers_doc"
792
	pkgdesc="$pkgdesc (documentation)"
793
	arch=${arch_doc:-"noarch"}
794

Natanael Copa's avatar
Natanael Copa committed
795
	local i
796
	for i in doc man info html sgml licenses gtk-doc; do
797 798 799
		if [ -d "$pkgdir/usr/share/$i" ]; then
			mkdir -p "$subpkgdir/usr/share"
			mv "$pkgdir/usr/share/$i" "$subpkgdir/usr/share/"
Natanael Copa's avatar
Natanael Copa committed
800 801
		fi
	done
802 803 804
	
	rm -f "$subpkgdir/usr/share/info/dir"

805 806 807
#	# compress info and man pages
#	find "$subpkgdir/usr/share" \( -name '*.info' -o -name '*.info-[1-9]' \
#		-o -name '*.[1-9]' \) -exec gzip {} \;
808 809 810 811

	# remove if empty, ignore error (not empty)
	rmdir "$pkgdir/usr/share" "$pkgdir/usr" 2>/dev/null

Natanael Copa's avatar
Natanael Copa committed
812
#	[ -d "$subpkgdir/usr/share/man" ] && depends="man"
Natanael Copa's avatar
Natanael Copa committed
813 814 815
	return 0
}

816 817 818 819
doc() {
	default_doc
}

820
# predefined splitfunc mod
821
default_mod() {
822
	depends="$kernel $depends_mod"
823
	install="$install_mod"
Natanael Copa's avatar
Natanael Copa committed
824
	for i in firmware modules; do
825 826 827
		if [ -d "$pkgdir/lib/$i" ]; then
			rm -rf "$subpkgdir/lib"
			mkdir -p "$subpkgdir/lib"
828
			mv "$pkgdir/lib/$i" "$subpkgdir/lib"
Natanael Copa's avatar
Natanael Copa committed
829 830 831 832
		fi
	done
}

833 834 835 836
mod() {
	default_mod
}

837
# predefined splitfunc dev
838
default_dev() {
839
	local i= j=
840
	depends="$pkgname $depends_dev"
841
	install="$install_dev"
Natanael Copa's avatar
Natanael Copa committed
842
	triggers="$triggers_dev"
843 844
	pkgdesc="$pkgdesc (development files)"

845 846 847 848
	for i in $origsubpackages; do
		[ "${i%:*}" = "$subpkgname" ] || depends="$depends ${i%:*}"
	done
		
849
	cd "$pkgdir" || return 0
850 851
	for i in usr/include usr/lib/pkgconfig usr/share/aclocal\
			usr/share/gettext usr/bin/*-config	\
852
			usr/share/vala/vapi usr/share/gir-[0-9]*\
853 854 855
			$(find -name include -type d) 		\
			$(find usr/ -name '*.[acho]' -o -name '*.la' \
			2>/dev/null); do
856 857
		if [ -e "$pkgdir/$i" ] || [ -L "$pkgdir/$i" ]; then
			d="$subpkgdir/${i%/*}"	# dirname $i
Natanael Copa's avatar
Natanael Copa committed
858
			mkdir -p "$d"
859
			mv "$pkgdir/$i" "$d"
860
			rmdir "$pkgdir/${i%/*}" 2>/dev/null
Natanael Copa's avatar
Natanael Copa committed
861 862
		fi
	done
863 864 865 866 867 868 869
	# move *.so links needed when linking the apps to -dev packages
	for i in lib/*.so usr/lib/*.so; do
		if [ -L "$i" ]; then
			mkdir -p "$subpkgdir"/"${i%/*}"
			mv "$i" "$subpkgdir/$i" || return 1
		fi
	done
Natanael Copa's avatar
Natanael Copa committed
870
	return 0
Natanael Copa's avatar
Natanael Copa committed
871 872
}

873 874 875 876
dev() {
	default_dev
}

877 878 879 880
is_function() {
	type "$1" 2>&1 | head -n 1 | egrep -q "is a (shell )?function"
}

Natanael Copa's avatar
Natanael Copa committed
881 882
# build and package in fakeroot
rootpkg() {
883 884 885 886
	local do_build=build
	cd "$startdir"
	if is_function package; then
		build || return 1
887
		do_build=package
888
	fi
Natanael Copa's avatar
Natanael Copa committed
889
	cd "$startdir"
890
	[ -n "$FAKEROOT" ] && msg "Entering fakeroot..."
891
	$FAKEROOT -- "$abuild_path" $color_opt $do_build \
892
		prepare_subpackages \
893
		prepare_language_packs \
894
		prepare_package \
895
		create_apks
Natanael Copa's avatar
Natanael Copa committed
896 897 898
}

srcpkg() {
899
	getpkgver || return 1
900
	local p="$pkgname-$pkgver-$pkgrel"
Natanael Copa's avatar
Natanael Copa committed
901
	local prefix="${startdir##*/}"
Natanael Copa's avatar
Natanael Copa committed
902 903 904 905 906
	local i files="$prefix/APKBUILD"
	for i in $source; do
		files="$files $prefix/${i##*/}"
	done
	mkdir -p "$PKGDEST"
907
	msg "Creating source package $p.src.tar.gz..."
908
	(cd .. && tar -zcf "$PKGDEST/$p.src.tar.gz" $files) 
Natanael Copa's avatar
Natanael Copa committed
909 910
}

Natanael Copa's avatar
Natanael Copa committed
911 912
# return true if arch is supported or noarch
check_arch() {
Natanael Copa's avatar
Natanael Copa committed
913
	list_has $CARCH $arch || [ "$arch" = "noarch" ] || [ "$arch" = "all" ]
Natanael Copa's avatar
Natanael Copa committed
914 915
}

916
# check if package is up to date
917
apk_up2date() {
918
	getpkgver || return 1
919
	local pkg="$PKGDEST/$pkgname-$pkgver-r$pkgrel.apk"
920
	local i s
Natanael Copa's avatar
Natanael Copa committed
921
	cd "$startdir"
922 923 924 925 926
	for i in $pkgname $subpackages; do
		[ -f "$PKGDEST/$pkgname-$pkgver-r$pkgrel.apk" ] || return 1
	done
	[ -n "$keep" ] && return 0

927
	for i in $source APKBUILD; do
928 929 930 931 932 933
		local s
		if is_remote "$i"; then
			s="$SRCDEST/${i##*/}"	# $(basename $i)
		else
			s="$startdir/${i##*/}"
		fi
934 935 936 937 938 939 940
		if [ "$s" -nt "$pkg" ]; then
			return 1
		fi
	done
	return 0
}

941
abuildindex_up2date() {
942
	local i apk
943
	getpkgver || return 1
944 945
	for i in $pkgname $subpackages; do
		apk="${i%:*}-$pkgver-r$pkgrel.apk"
946
		[ "$abuildrepo"/APKINDEX.tar.gz -nt "$abuildrepo"/$apk ] || return 1
947 948 949 950 951
	done
	return 0
}

up2date() {
Natanael Copa's avatar
Natanael Copa committed
952
	check_arch || return 0
953 954 955 956 957 958 959
	apk_up2date && abuildindex_up2date
}

# rebuild package and abuildrepo index if needed
abuildindex() {
	up2date && return 0
	update_abuildrepo
960 961
}

962 963 964 965 966 967 968
# source all APKBUILDs and output:
#  1) origin of package
#  2) all dependencies
# the output is i in a format easy parseable for awk
depparse_aports() {
	# lets run this in a subshell since we source all APKBUILD here
	(
969 970
	aportsdir=$(realpath ${APKBUILD%/APKBUILD}/..)
	for i in $aportsdir/*/APKBUILD; do
971 972 973 974
		pkgname=
		subpackages=
		depends=
		makedepends=
975
		. $i
976
		dir=${i%/APKBUILD}
977
		deps=
978
		# filter out conflicts from deps and version info
979 980 981 982
		for j in $depends $makedepends; do
			case "$j" in
				!*) continue;;
			esac
983
			deps="$deps ${j%%[<>=]*}"
984
		done
985
		for j in $pkgname $subpackages; do
986
			echo "o ${j%%:*} $dir"
987
			set -- $deps
988 989 990 991 992 993 994
			echo -n "d ${j%%:*} $1"
			shift
			while [ $# -gt 0 ]; do
				echo -n ",$1"
				shift
			done
			echo
995 996
		done
	done
997
	)
998 999
}

1000
deptrace() {
1001 1002 1003
	local deps= i=
	# strip versions from deps
	for i in "$@"; do
1004
		deps="$deps ${i%%[<>=]*}"
1005
	done
1006
	[ -z "$deps" ] && return 0
1007 1008 1009
	( 	depparse_aports 
		if [ -z "$upgrade" ]; then
			# list installed pkgs and prefix with 'i '
1010
			$APK info -q | sort |  sed 's/^/i /'
1011
		fi
1012
	) | awk -v pkgs="$deps" '
1013 1014 1015 1016 1017 1018 1019 1020 1021 1022 1023 1024 1025 1026 1027 1028 1029 1030 1031 1032 1033 1034 1035 1036 1037

	function depgraph(pkg,	a, i) {
		if (visited[pkg])
			return 0;
		visited[pkg] = 1;
		split(deps[pkg], a, ",");
		for (i in a)
			depgraph(a[i]);
		print pkg ":" origin[pkg];

	}

	$1 == "i" { visited[$2] = 1 }
	$1 == "o" { origin[$2] = $3 }
	$1 == "d" { deps[$2] = $3 }
	END {
		split(pkgs, pkgarray);
		for (i in pkgarray)
			depgraph(pkgarray[i]);
	}
	'
}

# build and install dependencies
builddeps() {
1038
	local deps= alldeps= pkg= i= dir= ver= missing= installed_deps=
1039
	local filtered_deps= conflicts=
1040
	[ -n "$nodeps" ] && return 0
1041
	msg "Analyzing dependencies..."
1042

1043 1044 1045
	# add depends unless it is a subpackage or package itself
	for i in $BUILD_BASE $depends $makedepends; do
		[ "$pkgname" = "${i%%[<>=]*}" ] && continue
1046
		subpackages_has ${i%%[<>=]*} || deps="$deps $i"
1047 1048
	done

1049
	installed_deps=$($APK info -e $deps)
1050
	# find which deps are missing
1051
	for i in $deps; do
1052
		if [ "${i#\!}" != "$i" ]; then
1053
			$APK info -q -e "${i#\!}" \
1054
				&& conflicts="$conflicts ${i#\!}"
1055
		elif ! deplist_has $i $installed_deps || [ -n "$upgrade" ]; then
1056 1057 1058
			missing="$missing $i"
		fi
	done
1059
	
1060
	if [ -n "$conflicts" ]; then
1061 1062
		error "Conflicting package(s) installed:$conflicts"
		return 1
1063 1064 1065 1066 1067 1068 1069 1070
	fi
	
	if [ -z "$install_deps" ] && [ -z "$recursive" ]; then
		# if we dont have any missing deps we are done now
		[ -z "$missing" ] && return 0
		error "Missing dependencies: $missing Use -r to autoinstall or -R to build"
		return 1
	fi
1071

1072
	uninstall_after=".makedepends-$pkgname $uninstall_after"
1073
	if [ -n "$install_deps" ] && [ -z "$recursive" ] && [ -n "$deps" ]; then
1074 1075
		# make a --simluate run first to detect missing deps
		# apk-tools --virtual is no goot at reporting those.
1076
		$SUDO $APK add --repository "$abuildrepo" \
1077 1078
			--wait 30 \
			--simulate --quiet $deps || return 1
1079
		$SUDO $APK add --repository "$abuildrepo" \
1080
			--wait 30 \
1081 1082
			--virtual .makedepends-$pkgname $deps \
			&& return 0
1083
	fi
1084 1085
	
	[ -z "$recursive" ] && return 1
1086 1087 1088

	# find dependencies that are installed but missing in repo.
	for i in $deps; do
1089
		local m=$($APK search --repository "$abuildrepo" ${i%%[<>=]*})
Natanael Copa's avatar
Natanael Copa committed
1090
		if [ -z "$m" ]; then
1091 1092 1093
			missing="$missing $i"
		fi
	done
1094 1095
	
	for i in $(deptrace $missing); do
1096 1097 1098
		# i = pkg:dir
		local dir=${i#*:}
		local pkg=${i%:*}
1099 1100 1101 1102 1103 1104 1105 1106 1107 1108

		# ignore if dependency is in other repo
		[ -d "$dir" ] || continue
		
		# break cricular deps
		list_has $pkg $ABUILD_VISITED && continue
		export ABUILD_VISITED="$ABUILD_VISITED $pkg"

		msg "Entering $dir"
		cd "$dir" && $0 $forceroot $keep $quiet $install_deps \
1109
			$recursive $upgrade $color_opt abuildindex || return 1
1110
	done
1111
	$SUDO $APK add -u --repository "$abuildrepo" \
1112
		--wait 30 \
1113
		--virtual .makedepends-$pkgname $deps
1114 1115
}

1116
# replace the md5sums in the APKBUILD
Natanael Copa's avatar
Natanael Copa committed
1117 1118
checksum() {
	local s files
1119
	[ -z "$source" ] && return 0
Natanael Copa's avatar
Natanael Copa committed
1120
	fetch
1121
	msg "Updating the md5sums in APKBUILD..."
Natanael Copa's avatar
Natanael Copa committed
1122 1123 1124 1125
	for s in $source; do
		files="$files ${s##*/}"
	done
	md5sums="$(cd "$srcdir" && md5sum $files)" || die "md5sum failed"